#ifndef _3DCASTE_MENU
#define _3DCASTE_MENU

#define GK(x) if(keys[x])
#define GKT(x) if(!keys[x] && keytemp[x])




int resx,resy;
int f,b;

bool init_quit=false;


typedef struct{
        char str[100];
        int nr;
        int pos_x;
        int pos_y;
        bool IsSet;
}MenuEntry;



LRESULT CALLBACK Menu_WndProc(  HWND        hWnd,                        // Handle For This Window
                                UINT        uMsg,                        // Message For This Window
                                WPARAM        wParam,                        // Additional Message Information
                                LPARAM        lParam);
/********************************************************************/

class Menu{
      public:
bool active;    
bool init_done;        
HDC        hDC;                        // Permanent Rendering Context
HWND        hWnd;                // Private GDI Device Context
HGLRC        hRC;                // Holds Our Window Handle
bool        keys[256];
bool keytemp[256];
int menu_nr;
int menu_switch;
bool fullscreen;
texture_t ftex;
texture_t logotex;

MenuEntry *entrys;


Menu(){
             hDC=NULL;                        // Permanent Rendering Context
       hWnd=NULL;                // Private GDI Device Context
       hRC=NULL;                // Holds Our Window Handle
       active=true;
       menu_nr=0;
       menu_switch=4;
       fullscreen=false;
       init_done=false;
}
             
             //Gre festlegen
GLvoid ReSizeGLScene(GLsizei width, GLsizei height)        // Resize And Initialize The GL Window
{
        if (height==0)                                        // Prevent A Divide By Zero By
        {
                height=1;                                // Making Height Equal One
        }

        glViewport(0, 0, width, height);                // Reset The Current Viewport

        // Matrix festlegen
        glMatrixMode(GL_PROJECTION);                        // Select The Projection Matrix
        glLoadIdentity();                                // Reset The Projection Matrix

        // Calculate The Aspect Ratio Of The Window
        gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,9999999.0f);

        glMatrixMode(GL_MODELVIEW);                        // Select The Modelview Matrix
        glLoadIdentity();                                // Reset The Modelview Matrix
}
             
GLvoid KillGLWindow(GLvoid)                                        // Properly Kill The Window
{
        if (fullscreen)                                                // Are We In Fullscreen Mode?
                {

                        ChangeDisplaySettings(NULL,0);
                        ShowCursor(TRUE);                                // Show Mouse Pointer
                }
        if (hRC)                                                // Do We Have A Rendering Context?
                {
        if (!wglMakeCurrent(NULL,NULL))                        // Are We Able To Release The DC And RC Contexts?
                        {
                 log_msg("Release Of DC And RC Failed.");
                        }
        if (!wglDeleteContext(hRC))                        // Are We Able To Delete The RC?
                        {
                         log_msg("Release Rendering Context Failed.");
                        }
                        hRC=NULL;                                        // Set RC To NULL
                }
         if (hDC && !ReleaseDC(hWnd,hDC))                        // Are We Able To Release The DC
                {
                        log_msg("Release Device Context Failed.");
                        hDC=NULL;                                        // Set DC To NULL
                }
        if (hWnd && !DestroyWindow(hWnd))                        // Are We Able To Destroy The Window?
                {
                        log_msg("Could Not Release hWnd.");
                        hWnd=NULL;                                        // Set hWnd To NULL
                }

}//KillGLWindow

int Menu_DrawGLScene(){
     Menu_GetKeys();
     glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
     glClearColor(0.0,0.0,0.0,0.0);
     glEnable(GL_TEXTURE_2D);
     glLoadIdentity();
     glBindTex(logotex);
     glEnable(GL_BLEND);
     glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);  
     glBegin(GL_QUADS);
     glColor4f(0.1,0.1,0.1,0.0);glTexVert(0.0,0.0,-1.0,-2,-7.0);
     glColor4f(0.7,0.7,0.7,1);glTexVert(1.0,0.0,5.0,-2,-7.0);
     glColor4f(0.7,0.7,0.7,1);glTexVert(1.0,1.0,5.0,2,-7.0);
     glColor4f(0.1,0.1,0.1,0.0);glTexVert(0.0,1.0,-1.0,2,-7.0);
     glEnd();
     glDisable(GL_BLEND);
     glBindTex(ftex);
     glPrintSmall(255,0,0,40,40,"3D-Caste-Settings (Change with Up/Down)");    
     for(int x=0;x<menu_nr;x++){
             PrintMenuEntry(x);        
     }
     glPrintSmall(255,0,0,40,420,"Press Enter to accept Settings");
     return TRUE;
};
void MainLoop(){
     MSG        msg;
     while(!init_done)                                                        // Loop That Runs Until done=TRUE
        {
        if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))                // Is There A Message Waiting?
                {
                if (msg.message==WM_QUIT)                        // Have We Received A Quit Message?
                        {
                                init_done=TRUE;                                // If So done=TRUE
                                init_quit=true;
                        }
                        else                                                // If Not, Deal With Window Messages
                        {
                                TranslateMessage(&msg);                        // Translate The Message
                                DispatchMessage(&msg);                        // Dispatch The Message
                        }
                }
                else                                                        // If There Are No Messages
                {

                // Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
                        if (active && keys[VK_ESCAPE])        // Updating View Only If Active
                        {
                              init_done=TRUE;                                        // ESC or DrawGLScene Signalled A Quit
                              init_quit=true;
                        }
                        else                                                        // Not Time To Quit, Update Screen
                        {
                                Menu_DrawGLScene();
                                
                                SwapBuffers(hDC);                                // Swap Buffers (Double Buffering)
                        }

	       }}
};

BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{

 GLuint                PixelFormat;                                // Holds The Results After Searching For A Match
 HINSTANCE        hInstance;                                // Holds The Instance Of The Application
 WNDCLASS        wc;                                        // Windows Class Structure
 DWORD                dwExStyle;                                // Window Extended Style
 DWORD                dwStyle;                                // Window Style
 fullscreen=fullscreenflag;                                // Set The Global Fullscreen Flag


hInstance                = GetModuleHandle(NULL);                // Grab An Instance For Our Window
        wc.style                = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;        // Redraw On Move, And Own DC For Window
        wc.lpfnWndProc                = (WNDPROC) Menu_WndProc;                        // WndProc Handles Messages
        wc.cbClsExtra                = 0;                                        // No Extra Window Data
        wc.cbWndExtra                = 0;                                        // No Extra Window Data
        wc.hInstance                = hInstance;                                // Set The Instance
        wc.hIcon                = LoadIcon(NULL, IDI_WINLOGO);                // Load The Default Icon
        wc.hCursor                = LoadCursor(NULL, IDC_ARROW);                // Load The Arrow Pointer
        wc.hbrBackground        = NULL;                                        // No Background Required For GL
        wc.lpszMenuName                = NULL;                                        // We Don't Want A Menu
        wc.lpszClassName        = "OpenGLSettings";                                // Set The Class Name


if (!RegisterClass(&wc))                                        // Attempt To Register The Window Class
        {
                log_msg("Failed To Register The Window Class.");
                return FALSE;                                                // Exit And Return FALSE
        }

 
        
#ifndef CW_USEDEFAULT
#define CW_USEDEFAULT 200
#endif

int pos_x=0;
int pos_y=0;
 if (fullscreen)                                                        // Are We Still In Fullscreen Mode?
        {
        dwExStyle=WS_EX_APPWINDOW;                                // Window Extended Style
                dwStyle=WS_POPUP;                                        // Windows Style
                ShowCursor(FALSE);                                        // Hide Mouse Pointer
        }
        else
        {
                dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;                // Window Extended Style
                dwStyle=WS_OVERLAPPEDWINDOW;                                // Windows Style
                pos_x=CW_USEDEFAULT;
                pos_y=CW_USEDEFAULT;

        }

if (!(hWnd=CreateWindowEx(        dwExStyle,                        // Extended Style For The Window
                                        "OpenGLSettings",                        // Class Name
                                        title,                                // Window Title
                                        WS_CLIPSIBLINGS |                // Required Window Style
                                        WS_CLIPCHILDREN |                // Required Window Style
                                        dwStyle,                        // Selected Window Style
                                        pos_x, pos_y,                                // Window Position
                                        width, height,                        // Selected Width And Height
                                        NULL,                                // No Parent Window
                                        NULL,                                // No Menu
                                        hInstance,                        // Instance
                                        NULL)))                                // Don't Pass Anything To WM_CREATE

                                        {
                KillGLWindow();                                                // Reset The Display
                log_msg("Window Creation Error.");
                return FALSE;                                                // Return FALSE
        }
static        PIXELFORMATDESCRIPTOR pfd=                                // pfd Tells Windows How We Want Things To Be
        {
                sizeof(PIXELFORMATDESCRIPTOR),                                // Size Of This Pixel Format Descriptor
                1,                                                        // Version Number
                PFD_DRAW_TO_WINDOW |                                        // Format Must Support Window
                PFD_SUPPORT_OPENGL |                                        // Format Must Support OpenGL
                PFD_DOUBLEBUFFER,                                        // Must Support Double Buffering
                PFD_TYPE_RGBA,                                                // Request An RGBA Format
                bits,                                                        // Select Our Color Depth
                0, 0, 0, 0, 0, 0,                                        // Color Bits Ignored
                0,                                                        // No Alpha Buffer
                0,                                                        // Shift Bit Ignored
                0,                                                        // No Accumulation Buffer
                0, 0, 0, 0,                                                // Accumulation Bits Ignored
                24,                                                        // 16Bit Z-Buffer (Depth Buffer)
                16,                                                        // No Stencil Buffer
                0,                                                        // No Auxiliary Buffer
                PFD_MAIN_PLANE,                                                // Main Drawing Layer
                0,                                                        // Reserved
                0, 0, 0                                                        // Layer Masks Ignored
        };


        if (!(hDC=GetDC(hWnd)))                                                // Did We Get A Device Context?
        {
                KillGLWindow();                                                // Reset The Display
                log_msg("Can't Create A GL Device Context.");
                return FALSE;                                                // Return FALSE
        }

         if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))                        // Did Windows Find A Matching Pixel Format?
        {
                KillGLWindow();                                                // Reset The Display
                log_msg("Can't Find A Suitable PixelFormat.");
                return FALSE;                                                // Return FALSE
        }

        if(!SetPixelFormat(hDC,PixelFormat,&pfd))                        // Are We Able To Set The Pixel Format?
        {
                KillGLWindow();                                                // Reset The Display
                log_msg("Can't Set The PixelFormat.");
                return FALSE;                                                // Return FALSE
        }

        if (!(hRC=wglCreateContext(hDC)))                                // Are We Able To Get A Rendering Context?
        {
                KillGLWindow();                                                // Reset The Display
                log_msg("Can't Create A GL Rendering Context.");
                return FALSE;                                                // Return FALSE
        }

        if(!wglMakeCurrent(hDC,hRC))                                        // Try To Activate The Rendering Context
        {
                KillGLWindow();                                                // Reset The Display
                log_msg("Can't Activate The GL Rendering Context.");
                return FALSE;                                                // Return FALSE
        }

        ShowWindow(hWnd,SW_SHOW);                                        // Show The Window
        SetForegroundWindow(hWnd);                                        // Slightly Higher Priority
        SetFocus(hWnd);                                                        // Sets Keyboard Focus To The Window
        ReSizeGLScene(width, height);                                        // Set Up Our Perspective GL Screen
        
        log_txt("Menu Init:");
        
        Menu_Init();
        MainLoop();
                return TRUE;                                                        // Success
}

//Entrys will be in the same order as they're created!!
void SetMenuEntry(char *name,int x,int y,bool set=false){
     sprintf(entrys[menu_nr].str,"%s",name);
     entrys[menu_nr].nr=menu_nr;
     entrys[menu_nr].pos_x=x;
     entrys[menu_nr].pos_y=y;
     entrys[menu_nr].IsSet=set;
     menu_nr++;
};

void SelectNone(){
       for(int x=0;x<menu_nr;x++){
             entrys[x].IsSet=false;       
     }   
};

void PrintMenuEntry(int nr){
     if(entrys[nr].IsSet) glPrintSmall(190,190,190,entrys[nr].pos_x,entrys[nr].pos_y,"%s",entrys[nr].str);
     else glPrintSmall(0,0,255,entrys[nr].pos_x,entrys[nr].pos_y,"%s",entrys[nr].str);
};

void Menu_GetKeys(){
     for(int x=0;x<256;x++) if(keys[x]) keytemp[x]=true;
     GKT(VK_DOWN){
                 keytemp[VK_DOWN]=false;
                 menu_switch++;
                 if(menu_switch>menu_nr) menu_switch=menu_nr-1;
                 SelectNone();
                 entrys[menu_switch].IsSet=true;
                 }
     GKT(VK_UP){
                keytemp[VK_UP]=false;
                menu_switch--;
                if(menu_switch<0) menu_switch=0;
                SelectNone();
                entrys[menu_switch].IsSet=true;
                }
     GK(VK_RETURN){
                   f=1;
                   switch(menu_switch){
                                       case 0:
                                            resx=800;
                                            resy=600;
                                            b=16;
                                            f=1;
                                            break;
                                       case 1:
                                            resx=1024;
                                            resy=786;
                                            b=16;
                                            f=1;
                                            break;
                                       case 2:
                                            resx=1600;
                                            resy=1200;
                                            b=16;
                                            f=1;
                                            break;
                                       case 3:
                                            resx=800;
                                            resy=600;
                                            b=32;
                                            f=1;
                                            break;
                                       case 4:
                                            resx=1024;
                                            resy=768;
                                            b=32;
                                            f=1;
                                            break;
                                       case 5:
                                            resx=1600;
                                            resy=1200;
                                            b=32;
                                            f=1;
                                            break;
                                       case 6:
                                            resx=800;
                                            resy=600;
                                            b=16;
                                            f=0;
                                            break;
                                       case 7:
                                            resx=1024;
                                            resy=786;
                                            b=16;
                                            f=0;
                                            break;
                                       case 8:
                                            resx=1600;
                                            resy=1200;
                                            b=16;
                                            f=0;
                                            break;
                                       
                   }
                   init_done=true;
                   log_txt("Resolution %ix%i at %i bpp, Fullscreen: %i",resx,resy,b,(int)f);
                   if(f==1)
                   fullscreen=true;
                   KillGLWindow();
                    }//GK return
                    
};

void Menu_Init(){
     entrys=(MenuEntry *)malloc(sizeof(MenuEntry)*15);    
     SetMenuEntry("800 x600 x 16bpp x Fullscreen",40,100);
     SetMenuEntry("1024x768 x 16bpp x Fullscreen",40,130);
     SetMenuEntry("1600x1200x 16bpp x Fullscreen",40,160);
     SetMenuEntry("800 x600 x 32bpp x Fullscreen",40,190);
     SetMenuEntry("1024x768 x 32bpp x Fullscreen",40,220,true);
     menu_switch=menu_nr-1;
     SetMenuEntry("1600x1200x 32bpp x Fullscreen",40,250);
     SetMenuEntry("800 x600 x Windowed",40,300);
     SetMenuEntry("1024x768 x Windowed",40,330);
     SetMenuEntry("1600x1200x Windowed",40,360);
     
     FILE *config;
        config=fopen("data/settings.txt","rt");
        char fontstr[100],logofile[100];
        fscanf(config,"\n[FILES]\n\n");
        fscanf(config,"FONT: %s \n",&fontstr);
        fscanf(config,"LOGO: %s\n",&logofile);
        ftex=LoadTexture(fontstr,false);
        logotex=LoadTexture(logofile);
        glBuildFont(ftex);
        fclose(config);
};


};//class Menu

Menu menu;


LRESULT CALLBACK Menu_WndProc(  HWND        hWnd,                        // Handle For This Window
                                UINT        uMsg,                        // Message For This Window
                                WPARAM        wParam,                        // Additional Message Information
                                LPARAM        lParam)                        // Additional Message Information
{

switch (uMsg)                                                // Check For Windows Messages
        {
case WM_ACTIVATE:                                // Watch For Window Activate Message
                {
                        if (!HIWORD(wParam))                        // Check Minimization State
                        {
                                menu.active=TRUE;                        // Program Is Active
                        }
                        else
                        {
                                menu.active=FALSE;                        // Program Is No Longer Active
                        }

                        return 0;                                // Return To The Message Loop
                }
case WM_SYSCOMMAND:                                // Intercept System Commands
                {
                        switch (wParam)                                // Check System Calls
                        {
                                case SC_SCREENSAVE:                // Screensaver Trying To Start?
                                case SC_MONITORPOWER:                // Monitor Trying To Enter Powersave?
                                return 0;                        // Prevent From Happening
                        }
                        break;                                        // Exit
                }
case WM_CLOSE:                                        // Did We Receive A Close Message?
                {
                        PostQuitMessage(0);                        // Send A Quit Message
                        return 0;                                // Jump Back
                }
case WM_KEYDOWN:                                // Is A Key Being Held Down?
                {
                        menu.keys[wParam] = TRUE;                        // If So, Mark It As TRUE
                        return 0;                                // Jump Back
                }
case WM_KEYUP:                                        // Has A Key Been Released?
                {
                        menu.keys[wParam] = FALSE;                        // If So, Mark It As FALSE
                        return 0;                                // Jump Back
                }


 case WM_SIZE:                                        // Resize The OpenGL Window
                {
                        menu.ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
                        
                        return 0;                                // Jump Back
                }
        }
   // Pass All Unhandled Messages To DefWindowProc
        return DefWindowProc(hWnd,uMsg,wParam,lParam);
};

#endif
