#ifndef _3DCASTE_SHADER
#define _3DCASTE_SHADER

#include <gl/glext.h>

#ifdef GL_VERSION_1_4
PFNGLCREATESHADEROBJECTARBPROC glCreateShaderObjectARB=NULL;
PFNGLSHADERSOURCEARBPROC glShaderSourceARB=NULL;
PFNGLCOMPILESHADERARBPROC glCompileShaderARB=NULL;
PFNGLATTACHOBJECTARBPROC glAttachObjectARB=NULL;
PFNGLLINKPROGRAMARBPROC glLinkProgramARB=NULL;
PFNGLUSEPROGRAMOBJECTARBPROC glUseProgramObjectARB=NULL;
PFNGLCREATEPROGRAMOBJECTARBPROC glCreateProgramObjectARB=NULL;
PFNGLGETUNIFORMLOCATIONARBPROC glGetUniformLocationARB=NULL;
PFNGLUNIFORM3FARBPROC glUniform3fARB=NULL;
PFNGLUNIFORM1IARBPROC glUniform1iARB=NULL;
#endif

#define glShader GLenum

bool shader_Support;


void initGLShader(bool quit=false){
     if(strstr((char*)glGetString(GL_EXTENSIONS),"GL_ARB_shader_objects") && strstr((char*)glGetString(GL_EXTENSIONS),"GL_ARB_shading_language_100") && strstr((char*)glGetString(GL_EXTENSIONS),"GL_ARB_fragment_shader") && strstr((char*)glGetString(GL_EXTENSIONS),"GL_ARB_vertex_shader"))
     {
            shader_Support=true;
            log_txt("GLSL Supported!");
             glCreateShaderObjectARB=(PFNGLCREATESHADEROBJECTARBPROC)wglGetProcAddress("glCreateShaderObjectARB");
             glShaderSourceARB=(PFNGLSHADERSOURCEARBPROC) wglGetProcAddress("glShaderSourceARB");
                glCompileShaderARB=(PFNGLCOMPILESHADERARBPROC) wglGetProcAddress("glCompileShaderARB");
                glAttachObjectARB=(PFNGLATTACHOBJECTARBPROC) wglGetProcAddress("glAttachObjectARB");
                glLinkProgramARB=(PFNGLLINKPROGRAMARBPROC) wglGetProcAddress("glLinkProgramARB");
                glUseProgramObjectARB=(PFNGLUSEPROGRAMOBJECTARBPROC) wglGetProcAddress("glUseProgramObjectARB");
                glCreateProgramObjectARB=(PFNGLCREATEPROGRAMOBJECTARBPROC) wglGetProcAddress("glCreateProgramObjectARB");
                glGetUniformLocationARB=(PFNGLGETUNIFORMLOCATIONARBPROC) wglGetProcAddress("glGetUniformLocationARB");
                glUniform3fARB=(PFNGLUNIFORM3FARBPROC) wglGetProcAddress("glUniform3fARB");
                glUniform1iARB=(PFNGLUNIFORM1IARBPROC) wglGetProcAddress("glUniform1iARB");
     }
     else{
          shader_Support=false;
          if(!quit) log_txt("no GLSL Support!");
          else{
               log_msg("no GLSL Support!");
               exit(0);
               }
               
     }
}

glShader LoadGLShader(char fvs[50],char ffs[50]){
         glShader prog,vert,frag;
         
         #ifdef GL_VERSION_1_4
         log_txt("Loading GLSL shaders: %s %s",fvs,ffs);
         log_txt("shader creation");
         prog=glCreateProgramObjectARB();
         vert=glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
         frag=glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);    
         log_txt("loading file 1");
         FILE *f=fopen(fvs,"rt");
         if(f==NULL){
                     log_msg("Could not load Shader: %s",fvs);
                     exit(0);
                     }
         char *source=(char *)malloc(sizeof(char)*2000);
         for(int x=0;x<2000;x++){
                        if(!feof(f)) source[x]=fgetc(f);
                        else source[x]='\n';
         }    
         const char *tmp=source;
         log_txt("loading shader source 1");
         glShaderSourceARB(vert, 1, &tmp, NULL);
         
         f=fopen(ffs,"rt");
         if(f==NULL){
                     log_msg("Could not load Shader: %s",ffs);
                     exit(0);
                     }
         sprintf(source,"");
         
         for(int x=0;x<2000;x++){
                        if(!feof(f)) source[x]=fgetc(f);
                        else source[x]='\n';
         }    
         
         glShaderSourceARB(frag, 1, &tmp, NULL);
         log_txt("Compiling shader");
         glCompileShaderARB(vert);
         glCompileShaderARB(frag);
         log_txt("attaching shader to program");
         // Attach The Shader Objects To The Program Object
         glAttachObjectARB(prog, vert);     
         glAttachObjectARB(prog, frag);
         log_txt("linking program...");
         // Link The Program Object
         glLinkProgramARB(prog);
         log_txt("finished");
         #endif
         return prog;         
};

void glUnbindShader(){
#ifdef GL_VERSION_1_4
     glUseProgramObjectARB(0);     
#endif; 
};

#define glGUL(x,y) glGetUniformLocationARB(x, y)
void glPassTexToShader(glShader shd,char *var_name,int ARBunit=0){
#ifdef GL_VERSION_1_4
     glUniform1iARB(glGUL(shd,var_name),ARBunit);
#endif;
};

void glBindShader(glShader shd){
#ifdef GL_VERSION_1_4
     glUseProgramObjectARB(shd);     
#endif;
};



#endif
